Package: whisker
Maintainer: Edwin de Jonge <edwindjonge@gmail.com>
License: GPL-3
Title: {{mustache}} for R, Logicless Templating
Type: Package
LazyLoad: yes
Author: Edwin de Jonge
Description: Implements 'Mustache' logicless templating.
Version: 0.4.1
URL: https://github.com/edwindj/whisker
Suggests: markdown
RoxygenNote: 6.1.1
NeedsCompilation: no
Packaged: 2022-12-05 15:15:55 UTC; hornik
Repository: CRAN
Date/Publication: 2022-12-05 15:33:50 UTC
Built: R 4.6.0; ; 2026-05-28 04:06:49 UTC; unix

Package: whisker
Maintainer: Edwin de Jonge <edwindjonge@gmail.com>
License: GPL-3
Title: {{mustache}} for R, logicless templating
Type: Package
LazyLoad: yes
Author: Edwin de Jonge
Description: logicless templating, reuse templates in many programming
        languages including R
Version: 0.3-2
URL: http://github.com/edwindj/whisker
Date: 2010-12-23
Collate: 'whisker.R' 'section.R' 'parseTemplate.R' 'partials.R'
        'inverted.R' 'pkg.R' 'iteratelist.R' 'delim.R' 'markdown.R'
        'rowsplit.R'
Suggests: markdown
Packaged: 2013-04-27 22:49:33 UTC; Edwin
NeedsCompilation: no
Repository: CRAN
Date/Publication: 2013-04-28 07:55:20
Built: R 3.4.1; ; 2017-08-19 19:11:57 UTC; windows

# Automatically generated from specification file: 'sections.json'
#
# Section tags and End Section tags are used in combination to wrap a section
# of the template for iteration
# 
# These tags' content MUST be a non-whitespace character sequence NOT
# containing the current closing delimiter; each Section tag MUST be followed
# by an End Section tag with the same content within the same section.
# 
# This tag's content names the data to replace the tag.  Name resolution is as
# follows:
#   1) Split the name on periods; the first part is the name to resolve, any
#   remaining parts should be retained.
#   2) Walk the context stack from top to bottom, finding the first context
#   that is a) a hash containing the name as a key OR b) an object responding
#   to a method with the given name.
#   3) If the context is a hash, the data is the value associated with the
#   name.
#   4) If the context is an object and the method with the given name has an
#   arity of 1, the method SHOULD be called with a String containing the
#   unprocessed contents of the sections; the data is the value returned.
#   5) Otherwise, the data is the value returned by calling the method with
#   the given name.
#   6) If any name parts were retained in step 1, each should be resolved
#   against a context stack containing only the result from the former
#   resolution.  If any part fails resolution, the result should be considered
#   falsey, and should interpolate as the empty string.
# If the data is not of a list type, it is coerced into a list as follows: if
# the data is truthy (e.g. `!!data == true`), use a single-element list
# containing the data, otherwise use an empty list.
# 
# For each element in the data list, the element MUST be pushed onto the
# context stack, the section MUST be rendered, and the element MUST be popped
# off the context stack.
# 
# Section and End Section tags SHOULD be treated as standalone when
# appropriate.
# 
library(testthat)
context('Spec v1.1, sections')

test_that( "Truthy", {
  #"Truthy sections should have their contents rendered."
  template <- "\"{{#boolean}}This should be rendered.{{/boolean}}\""
  data <- list(boolean = TRUE)


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "\"This should be rendered.\"", label=deparse(str), info="Truthy sections should have their contents rendered.")
})

test_that( "Falsey", {
  #"Falsey sections should have their contents omitted."
  template <- "\"{{#boolean}}This should not be rendered.{{/boolean}}\""
  data <- list(boolean = FALSE)


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "\"\"", label=deparse(str), info="Falsey sections should have their contents omitted.")
})

test_that( "Context", {
  #"Objects and hashes should be pushed onto the context stack."
  template <- "\"{{#context}}Hi {{name}}.{{/context}}\""
  data <- list(context = list(name = "Joe"))


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "\"Hi Joe.\"", label=deparse(str), info="Objects and hashes should be pushed onto the context stack.")
})

test_that( "Deeply Nested Contexts", {
  #"All elements on the context stack should be accessible."
  template <- "{{#a}}\n{{one}}\n{{#b}}\n{{one}}{{two}}{{one}}\n{{#c}}\n{{one}}{{two}}{{three}}{{two}}{{one}}\n{{#d}}\n{{one}}{{two}}{{three}}{{four}}{{three}}{{two}}{{one}}\n{{#e}}\n{{one}}{{two}}{{three}}{{four}}{{five}}{{four}}{{three}}{{two}}{{one}}\n{{/e}}\n{{one}}{{two}}{{three}}{{four}}{{three}}{{two}}{{one}}\n{{/d}}\n{{one}}{{two}}{{three}}{{two}}{{one}}\n{{/c}}\n{{one}}{{two}}{{one}}\n{{/b}}\n{{one}}\n{{/a}}\n"
  data <- list(a = list(one = 1), b = list(two = 2), c = list(three = 3), 
    d = list(four = 4), e = list(five = 5))


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "1\n121\n12321\n1234321\n123454321\n1234321\n12321\n121\n1\n", label=deparse(str), info="All elements on the context stack should be accessible.")
})

test_that( "List", {
  #"Lists should be iterated; list items should visit the context stack."
  template <- "\"{{#list}}{{item}}{{/list}}\""
  data <- list(list = list(list(item = 1), list(item = 2), list(item = 3)))


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "\"123\"", label=deparse(str), info="Lists should be iterated; list items should visit the context stack.")
})

test_that( "Empty List", {
  #"Empty lists should behave like falsey values."
  template <- "\"{{#list}}Yay lists!{{/list}}\""
  data <- list(list = list())


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "\"\"", label=deparse(str), info="Empty lists should behave like falsey values.")
})

test_that( "Doubled", {
  #"Multiple sections per template should be permitted."
  template <- "{{#bool}}\n* first\n{{/bool}}\n* {{two}}\n{{#bool}}\n* third\n{{/bool}}\n"
  data <- list(two = "second", bool = TRUE)


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "* first\n* second\n* third\n", label=deparse(str), info="Multiple sections per template should be permitted.")
})

test_that( "Nested (Truthy)", {
  #"Nested truthy sections should have their contents rendered."
  template <- "| A {{#bool}}B {{#bool}}C{{/bool}} D{{/bool}} E |"
  data <- list(bool = TRUE)


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "| A B C D E |", label=deparse(str), info="Nested truthy sections should have their contents rendered.")
})

test_that( "Nested (Falsey)", {
  #"Nested falsey sections should be omitted."
  template <- "| A {{#bool}}B {{#bool}}C{{/bool}} D{{/bool}} E |"
  data <- list(bool = FALSE)


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "| A  E |", label=deparse(str), info="Nested falsey sections should be omitted.")
})

test_that( "Context Misses", {
  #"Failed context lookups should be considered falsey."
  template <- "[{{#missing}}Found key 'missing'!{{/missing}}]"
  data <- list()


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "[]", label=deparse(str), info="Failed context lookups should be considered falsey.")
})

test_that( "Implicit Iterator - String", {
  #"Implicit iterators should directly interpolate strings."
  template <- "\"{{#list}}({{.}}){{/list}}\""
  data <- list(list = c("a", "b", "c", "d", "e"))


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "\"(a)(b)(c)(d)(e)\"", label=deparse(str), info="Implicit iterators should directly interpolate strings.")
})

test_that( "Implicit Iterator - Integer", {
  #"Implicit iterators should cast integers to strings and interpolate."
  template <- "\"{{#list}}({{.}}){{/list}}\""
  data <- list(list = c(1, 2, 3, 4, 5))


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "\"(1)(2)(3)(4)(5)\"", label=deparse(str), info="Implicit iterators should cast integers to strings and interpolate.")
})

test_that( "Implicit Iterator - Decimal", {
  #"Implicit iterators should cast decimals to strings and interpolate."
  template <- "\"{{#list}}({{.}}){{/list}}\""
  data <- list(list = c(1.1, 2.2, 3.3, 4.4, 5.5))


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "\"(1.1)(2.2)(3.3)(4.4)(5.5)\"", label=deparse(str), info="Implicit iterators should cast decimals to strings and interpolate.")
})

test_that( "Dotted Names - Truthy", {
  #"Dotted names should be valid for Section tags."
  template <- "\"{{#a.b.c}}Here{{/a.b.c}}\" == \"Here\""
  data <- list(a = list(b = list(c = TRUE)))


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "\"Here\" == \"Here\"", label=deparse(str), info="Dotted names should be valid for Section tags.")
})

test_that( "Dotted Names - Falsey", {
  #"Dotted names should be valid for Section tags."
  template <- "\"{{#a.b.c}}Here{{/a.b.c}}\" == \"\""
  data <- list(a = list(b = list(c = FALSE)))


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "\"\" == \"\"", label=deparse(str), info="Dotted names should be valid for Section tags.")
})

test_that( "Dotted Names - Broken Chains", {
  #"Dotted names that cannot be resolved should be considered falsey."
  template <- "\"{{#a.b.c}}Here{{/a.b.c}}\" == \"\""
  data <- list(a = list())


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "\"\" == \"\"", label=deparse(str), info="Dotted names that cannot be resolved should be considered falsey.")
})

test_that( "Surrounding Whitespace", {
  #"Sections should not alter surrounding whitespace."
  template <- " | {{#boolean}}\t|\t{{/boolean}} | \n"
  data <- list(boolean = TRUE)


  str <- whisker.render(template, data=data)
  
  expect_equal(str, " | \t|\t | \n", label=deparse(str), info="Sections should not alter surrounding whitespace.")
})

test_that( "Internal Whitespace", {
  #"Sections should not alter internal whitespace."
  template <- " | {{#boolean}} {{! Important Whitespace }}\n {{/boolean}} | \n"
  data <- list(boolean = TRUE)


  str <- whisker.render(template, data=data)
  
  expect_equal(str, " |  \n  | \n", label=deparse(str), info="Sections should not alter internal whitespace.")
})

test_that( "Indented Inline Sections", {
  #"Single-line sections should not alter surrounding whitespace."
  template <- " {{#boolean}}YES{{/boolean}}\n {{#boolean}}GOOD{{/boolean}}\n"
  data <- list(boolean = TRUE)


  str <- whisker.render(template, data=data)
  
  expect_equal(str, " YES\n GOOD\n", label=deparse(str), info="Single-line sections should not alter surrounding whitespace.")
})

test_that( "Standalone Lines", {
  #"Standalone lines should be removed from the template."
  template <- "| This Is\n{{#boolean}}\n|\n{{/boolean}}\n| A Line\n"
  data <- list(boolean = TRUE)


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "| This Is\n|\n| A Line\n", label=deparse(str), info="Standalone lines should be removed from the template.")
})

test_that( "Indented Standalone Lines", {
  #"Indented standalone lines should be removed from the template."
  template <- "| This Is\n  {{#boolean}}\n|\n  {{/boolean}}\n| A Line\n"
  data <- list(boolean = TRUE)


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "| This Is\n|\n| A Line\n", label=deparse(str), info="Indented standalone lines should be removed from the template.")
})

test_that( "Standalone Line Endings", {
  #"\"\\r\\n\" should be considered a newline for standalone tags."
  template <- "|\r\n{{#boolean}}\r\n{{/boolean}}\r\n|"
  data <- list(boolean = TRUE)


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "|\r\n|", label=deparse(str), info="\"\\r\\n\" should be considered a newline for standalone tags.")
})

test_that( "Standalone Without Previous Line", {
  #"Standalone tags should not require a newline to precede them."
  template <- "  {{#boolean}}\n#{{/boolean}}\n/"
  data <- list(boolean = TRUE)


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "#\n/", label=deparse(str), info="Standalone tags should not require a newline to precede them.")
})

test_that( "Standalone Without Newline", {
  #"Standalone tags should not require a newline to follow them."
  template <- "#{{#boolean}}\n/\n  {{/boolean}}"
  data <- list(boolean = TRUE)


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "#\n/\n", label=deparse(str), info="Standalone tags should not require a newline to follow them.")
})

test_that( "Padding", {
  #"Superfluous in-tag whitespace should be ignored."
  template <- "|{{# boolean }}={{/ boolean }}|"
  data <- list(boolean = TRUE)


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "|=|", label=deparse(str), info="Superfluous in-tag whitespace should be ignored.")
})

# Automatically generated from specification file: 'delimiters.json'
#
# Set Delimiter tags are used to change the tag delimiters for all content
# following the tag in the current compilation unit.
# 
# The tag's content MUST be any two non-whitespace sequences (separated by
# whitespace) EXCEPT an equals sign ('=') followed by the current closing
# delimiter.
# 
# Set Delimiter tags SHOULD be treated as standalone when appropriate.
# 
library(testthat)
context('Spec v1.1, delimiters')

test_that( "Pair Behavior", {
  #"The equals sign (used on both sides) should permit delimiter changes."
  template <- "{{=<% %>=}}(<%text%>)"
  data <- list(text = "Hey!")


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "(Hey!)", label=deparse(str), info="The equals sign (used on both sides) should permit delimiter changes.")
})

test_that( "Special Characters", {
  #"Characters with special meaning regexen should be valid delimiters."
  template <- "({{=[ ]=}}[text])"
  data <- list(text = "It worked!")


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "(It worked!)", label=deparse(str), info="Characters with special meaning regexen should be valid delimiters.")
})

test_that( "Sections", {
  #"Delimiters set outside sections should persist."
  template <- "[\n{{#section}}\n  {{data}}\n  |data|\n{{/section}}\n\n{{= | | =}}\n|#section|\n  {{data}}\n  |data|\n|/section|\n]\n"
  data <- list(section = TRUE, data = "I got interpolated.")


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "[\n  I got interpolated.\n  |data|\n\n  {{data}}\n  I got interpolated.\n]\n", label=deparse(str), info="Delimiters set outside sections should persist.")
})

test_that( "Inverted Sections", {
  #"Delimiters set outside inverted sections should persist."
  template <- "[\n{{^section}}\n  {{data}}\n  |data|\n{{/section}}\n\n{{= | | =}}\n|^section|\n  {{data}}\n  |data|\n|/section|\n]\n"
  data <- list(section = FALSE, data = "I got interpolated.")


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "[\n  I got interpolated.\n  |data|\n\n  {{data}}\n  I got interpolated.\n]\n", label=deparse(str), info="Delimiters set outside inverted sections should persist.")
})

test_that( "Partial Inheritence", {
  #"Delimiters set in a parent template should not affect a partial."
  template <- "[ {{>include}} ]\n{{= | | =}}\n[ |>include| ]\n"
  data <- list(value = "yes")

  partials <- list(include = ".{{value}}.")
  str <- whisker.render(template, partials=partials, data=data)
  
  expect_equal(str, "[ .yes. ]\n[ .yes. ]\n", label=deparse(str), info="Delimiters set in a parent template should not affect a partial.")
})

test_that( "Post-Partial Behavior", {
  #"Delimiters set in a partial should not affect the parent template."
  template <- "[ {{>include}} ]\n[ .{{value}}.  .|value|. ]\n"
  data <- list(value = "yes")

  partials <- list(include = ".{{value}}. {{= | | =}} .|value|.")
  str <- whisker.render(template, partials=partials, data=data)
  
  expect_equal(str, "[ .yes.  .yes. ]\n[ .yes.  .|value|. ]\n", label=deparse(str), info="Delimiters set in a partial should not affect the parent template.")
})

test_that( "Surrounding Whitespace", {
  #"Surrounding whitespace should be left untouched."
  template <- "| {{=@ @=}} |"
  data <- list()


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "|  |", label=deparse(str), info="Surrounding whitespace should be left untouched.")
})

test_that( "Outlying Whitespace (Inline)", {
  #"Whitespace should be left untouched."
  template <- " | {{=@ @=}}\n"
  data <- list()


  str <- whisker.render(template, data=data)
  
  expect_equal(str, " | \n", label=deparse(str), info="Whitespace should be left untouched.")
})

test_that( "Standalone Tag", {
  #"Standalone lines should be removed from the template."
  template <- "Begin.\n{{=@ @=}}\nEnd.\n"
  data <- list()


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "Begin.\nEnd.\n", label=deparse(str), info="Standalone lines should be removed from the template.")
})

test_that( "Indented Standalone Tag", {
  #"Indented standalone lines should be removed from the template."
  template <- "Begin.\n  {{=@ @=}}\nEnd.\n"
  data <- list()


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "Begin.\nEnd.\n", label=deparse(str), info="Indented standalone lines should be removed from the template.")
})

test_that( "Standalone Line Endings", {
  #"\"\\r\\n\" should be considered a newline for standalone tags."
  template <- "|\r\n{{= @ @ =}}\r\n|"
  data <- list()


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "|\r\n|", label=deparse(str), info="\"\\r\\n\" should be considered a newline for standalone tags.")
})

test_that( "Standalone Without Previous Line", {
  #"Standalone tags should not require a newline to precede them."
  template <- "  {{=@ @=}}\n="
  data <- list()


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "=", label=deparse(str), info="Standalone tags should not require a newline to precede them.")
})

test_that( "Standalone Without Newline", {
  #"Standalone tags should not require a newline to follow them."
  template <- "=\n  {{=@ @=}}"
  data <- list()


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "=\n", label=deparse(str), info="Standalone tags should not require a newline to follow them.")
})

test_that( "Pair with Padding", {
  #"Superfluous in-tag whitespace should be ignored."
  template <- "|{{= @   @ =}}|"
  data <- list()


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "||", label=deparse(str), info="Superfluous in-tag whitespace should be ignored.")
})

# Automatically generated from specification file: 'partials.json'
#
# Partial tags are used to expand an external template into the current
# template.
# 
# The tag's content MUST be a non-whitespace character sequence NOT containing
# the current closing delimiter.
# 
# This tag's content names the partial to inject.  Set Delimiter tags MUST NOT
# affect the parsing of a partial.  The partial MUST be rendered against the
# context stack local to the tag.
# 
# Partial tags SHOULD be treated as standalone when appropriate.  If this tag
# is used standalone, any whitespace preceding the tag should treated as
# indentation, and prepended to each line of the partial before rendering.
# 
library(testthat)
context('Spec v1.1, partials')

test_that( "Basic Behavior", {
  #"The greater-than operator should expand to the named partial."
  template <- "\"{{>text}}\""
  data <- list()

  partials <- list(text = "from partial")
  str <- whisker.render(template, partials=partials, data=data)
  
  expect_equal(str, "\"from partial\"", label=deparse(str), info="The greater-than operator should expand to the named partial.")
})

test_that( "Context", {
  #"The greater-than operator should operate within the current context."
  template <- "\"{{>partial}}\""
  data <- list(text = "content")

  partials <- list(partial = "*{{text}}*")
  str <- whisker.render(template, partials=partials, data=data)
  
  expect_equal(str, "\"*content*\"", label=deparse(str), info="The greater-than operator should operate within the current context.")
})

test_that( "Recursion", {
  #"The greater-than operator should properly recurse."
  template <- "{{>node}}"
  data <- list(content = "X", nodes = list(list(content = "Y", nodes = list())))

  partials <- list(node = "{{content}}<{{#nodes}}{{>node}}{{/nodes}}>")
  str <- whisker.render(template, partials=partials, data=data)
  
  expect_equal(str, "X<Y<>>", label=deparse(str), info="The greater-than operator should properly recurse.")
})

test_that( "Surrounding Whitespace", {
  #"The greater-than operator should not alter surrounding whitespace."
  template <- "| {{>partial}} |"
  data <- list()

  partials <- list(partial = "\t|\t")
  str <- whisker.render(template, partials=partials, data=data)
  
  expect_equal(str, "| \t|\t |", label=deparse(str), info="The greater-than operator should not alter surrounding whitespace.")
})

test_that( "Inline Indentation", {
  #"Whitespace should be left untouched."
  template <- "  {{data}}  {{> partial}}\n"
  data <- list(data = "|")

  partials <- list(partial = ">\n>")
  str <- whisker.render(template, partials=partials, data=data)
  
  expect_equal(str, "  |  >\n>\n", label=deparse(str), info="Whitespace should be left untouched.")
})

test_that( "Standalone Line Endings", {
  #"\"\\r\\n\" should be considered a newline for standalone tags."
  template <- "|\r\n{{>partial}}\r\n|"
  data <- list()

  partials <- list(partial = ">")
  str <- whisker.render(template, partials=partials, data=data)
  
  expect_equal(str, "|\r\n>|", label=deparse(str), info="\"\\r\\n\" should be considered a newline for standalone tags.")
})

test_that( "Standalone Without Previous Line", {
  #"Standalone tags should not require a newline to precede them."
  template <- "  {{>partial}}\n>"
  data <- list()

  partials <- list(partial = ">\n>")
  str <- whisker.render(template, partials=partials, data=data)
  
  expect_equal(str, "  >\n  >>", label=deparse(str), info="Standalone tags should not require a newline to precede them.")
})

test_that( "Standalone Without Newline", {
  #"Standalone tags should not require a newline to follow them."
  template <- ">\n  {{>partial}}"
  data <- list()

  partials <- list(partial = ">\n>")
  str <- whisker.render(template, partials=partials, data=data)
  
  expect_equal(str, ">\n  >\n  >", label=deparse(str), info="Standalone tags should not require a newline to follow them.")
})

test_that( "Standalone Indentation", {
  #"Each line of the partial should be indented before rendering."
  template <- "\\\n {{>partial}}\n/\n"
  data <- list(content = "<\n->")

  partials <- list(partial = "|\n{{{content}}}\n|\n")
  str <- whisker.render(template, partials=partials, data=data)
  
  expect_equal(str, "\\\n |\n <\n->\n |\n/\n", label=deparse(str), info="Each line of the partial should be indented before rendering.")
})

test_that( "Padding Whitespace", {
  #"Superfluous in-tag whitespace should be ignored."
  template <- "|{{> partial }}|"
  data <- list(boolean = TRUE)

  partials <- list(partial = "[]")
  str <- whisker.render(template, partials=partials, data=data)
  
  expect_equal(str, "|[]|", label=deparse(str), info="Superfluous in-tag whitespace should be ignored.")
})

# Automatically generated from specification file: 'comments.json'
#
# Comment tags represent content that should never appear in the resulting
# output.
# 
# The tag's content may contain any substring (including newlines) EXCEPT the
# closing delimiter.
# 
# Comment tags SHOULD be treated as standalone when appropriate.
# 
library(testthat)
context('Spec v1.1, comments')

test_that( "Inline", {
  #"Comment blocks should be removed from the template."
  template <- "12345{{! Comment Block! }}67890"
  data <- list()


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "1234567890", label=deparse(str), info="Comment blocks should be removed from the template.")
})

test_that( "Multiline", {
  #"Multiline comments should be permitted."
  template <- "12345{{!\n  This is a\n  multi-line comment...\n}}67890\n"
  data <- list()


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "1234567890\n", label=deparse(str), info="Multiline comments should be permitted.")
})

test_that( "Standalone", {
  #"All standalone comment lines should be removed."
  template <- "Begin.\n{{! Comment Block! }}\nEnd.\n"
  data <- list()


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "Begin.\nEnd.\n", label=deparse(str), info="All standalone comment lines should be removed.")
})

test_that( "Indented Standalone", {
  #"All standalone comment lines should be removed."
  template <- "Begin.\n  {{! Indented Comment Block! }}\nEnd.\n"
  data <- list()


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "Begin.\nEnd.\n", label=deparse(str), info="All standalone comment lines should be removed.")
})

test_that( "Standalone Line Endings", {
  #"\"\\r\\n\" should be considered a newline for standalone tags."
  template <- "|\r\n{{! Standalone Comment }}\r\n|"
  data <- list()


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "|\r\n|", label=deparse(str), info="\"\\r\\n\" should be considered a newline for standalone tags.")
})

test_that( "Standalone Without Previous Line", {
  #"Standalone tags should not require a newline to precede them."
  template <- "  {{! I'm Still Standalone }}\n!"
  data <- list()


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "!", label=deparse(str), info="Standalone tags should not require a newline to precede them.")
})

test_that( "Standalone Without Newline", {
  #"Standalone tags should not require a newline to follow them."
  template <- "!\n  {{! I'm Still Standalone }}"
  data <- list()


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "!\n", label=deparse(str), info="Standalone tags should not require a newline to follow them.")
})

test_that( "Multiline Standalone", {
  #"All standalone comment lines should be removed."
  template <- "Begin.\n{{!\nSomething's going on here...\n}}\nEnd.\n"
  data <- list()


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "Begin.\nEnd.\n", label=deparse(str), info="All standalone comment lines should be removed.")
})

test_that( "Indented Multiline Standalone", {
  #"All standalone comment lines should be removed."
  template <- "Begin.\n  {{!\n    Something's going on here...\n  }}\nEnd.\n"
  data <- list()


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "Begin.\nEnd.\n", label=deparse(str), info="All standalone comment lines should be removed.")
})

test_that( "Indented Inline", {
  #"Inline comments should not strip whitespace"
  template <- "  12 {{! 34 }}\n"
  data <- list()


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "  12 \n", label=deparse(str), info="Inline comments should not strip whitespace")
})

test_that( "Surrounding Whitespace", {
  #"Comment removal should preserve surrounding whitespace."
  template <- "12345 {{! Comment Block! }} 67890"
  data <- list()


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "12345  67890", label=deparse(str), info="Comment removal should preserve surrounding whitespace.")
})

# Create testthat test from the specification file for Mustache, so it can be
# tested if lives up to the specification
# 
# Please note:
# * You'll need rjson for reading the specifications
# * an installed whisker, because that is used for the generation of the test 
#   (eat your own dog food...)

library(rjson)
library(whisker)

header <- 
"# Automatically generated from specification file: '{{file}}'
#
{{overview}}
library(testthat)
context('Spec v1.1, {{type}}')
"
testtemplate <- 
"test_that( {{&name}}, {
  #{{&desc}}
  template <- {{&template}}
  data <- {{&data}}

{{#partials}}
  partials <- {{&partials}}
  str <- whisker.render(template, partials=partials, data=data)
{{/partials}}
{{^partials}}
  str <- whisker.render(template, data=data)
{{/partials}}
  
  expect_equal(str, {{&expected}}, label=deparse(str), info={{&desc}})
})
"

convertToTest <- function(files){
  for (json in files){
    writeSpec(json)
  }
}

writeSpec <- function(file){
  outfile <- gsub("^(.+).json", "../tests/test\\1.R", file)
  spec <- fromJSON(file=file)
  con <- file(outfile, open="wt")
  on.exit(close(con))
  
  spec$file <- file
  spec$overview <- gsub("(^|\n)", "\\1# ", spec$overview)
  spec$type <- gsub(".json", "", file)

  writeLines(whisker.render(header, data=spec), con) 
  test <- sapply(spec$test, writeTest)
  writeLines(test, con)
}

writeTest <- function(test){
  test <- lapply(test, deparse, control=c("keepNA"))  
  test$data <- paste(test$data, collapse="\n")
  whisker.render(testtemplate, data=test)
}

spec <- c( "interpolation.json"
         , "comments.json"
         , "inverted.json"
         , "sections.json"
         , "partials.json"
         , "delimiters.json"
         #, "lambdas.json"
         )
convertToTest(spec)

# Automatically generated from specification file: 'inverted.json'
#
# Inverted Section tags and End Section tags are used in combination to wrap a
# section of the template.
# 
# These tags' content MUST be a non-whitespace character sequence NOT
# containing the current closing delimiter; each Inverted Section tag MUST be
# followed by an End Section tag with the same content within the same
# section.
# 
# This tag's content names the data to replace the tag.  Name resolution is as
# follows:
#   1) Split the name on periods; the first part is the name to resolve, any
#   remaining parts should be retained.
#   2) Walk the context stack from top to bottom, finding the first context
#   that is a) a hash containing the name as a key OR b) an object responding
#   to a method with the given name.
#   3) If the context is a hash, the data is the value associated with the
#   name.
#   4) If the context is an object and the method with the given name has an
#   arity of 1, the method SHOULD be called with a String containing the
#   unprocessed contents of the sections; the data is the value returned.
#   5) Otherwise, the data is the value returned by calling the method with
#   the given name.
#   6) If any name parts were retained in step 1, each should be resolved
#   against a context stack containing only the result from the former
#   resolution.  If any part fails resolution, the result should be considered
#   falsey, and should interpolate as the empty string.
# If the data is not of a list type, it is coerced into a list as follows: if
# the data is truthy (e.g. `!!data == true`), use a single-element list
# containing the data, otherwise use an empty list.
# 
# This section MUST NOT be rendered unless the data list is empty.
# 
# Inverted Section and End Section tags SHOULD be treated as standalone when
# appropriate.
# 
library(testthat)
context('Spec v1.1, inverted')

test_that( "Falsey", {
  #"Falsey sections should have their contents rendered."
  template <- "\"{{^boolean}}This should be rendered.{{/boolean}}\""
  data <- list(boolean = FALSE)


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "\"This should be rendered.\"", label=deparse(str), info="Falsey sections should have their contents rendered.")
})

test_that( "Truthy", {
  #"Truthy sections should have their contents omitted."
  template <- "\"{{^boolean}}This should not be rendered.{{/boolean}}\""
  data <- list(boolean = TRUE)


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "\"\"", label=deparse(str), info="Truthy sections should have their contents omitted.")
})

test_that( "Context", {
  #"Objects and hashes should behave like truthy values."
  template <- "\"{{^context}}Hi {{name}}.{{/context}}\""
  data <- list(context = list(name = "Joe"))


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "\"\"", label=deparse(str), info="Objects and hashes should behave like truthy values.")
})

test_that( "List", {
  #"Lists should behave like truthy values."
  template <- "\"{{^list}}{{n}}{{/list}}\""
  data <- list(list = list(list(n = 1), list(n = 2), list(n = 3)))


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "\"\"", label=deparse(str), info="Lists should behave like truthy values.")
})

test_that( "Empty List", {
  #"Empty lists should behave like falsey values."
  template <- "\"{{^list}}Yay lists!{{/list}}\""
  data <- list(list = list())


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "\"Yay lists!\"", label=deparse(str), info="Empty lists should behave like falsey values.")
})

test_that( "Doubled", {
  #"Multiple inverted sections per template should be permitted."
  template <- "{{^bool}}\n* first\n{{/bool}}\n* {{two}}\n{{^bool}}\n* third\n{{/bool}}\n"
  data <- list(two = "second", bool = FALSE)


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "* first\n* second\n* third\n", label=deparse(str), info="Multiple inverted sections per template should be permitted.")
})

test_that( "Nested (Falsey)", {
  #"Nested falsey sections should have their contents rendered."
  template <- "| A {{^bool}}B {{^bool}}C{{/bool}} D{{/bool}} E |"
  data <- list(bool = FALSE)


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "| A B C D E |", label=deparse(str), info="Nested falsey sections should have their contents rendered.")
})

test_that( "Nested (Truthy)", {
  #"Nested truthy sections should be omitted."
  template <- "| A {{^bool}}B {{^bool}}C{{/bool}} D{{/bool}} E |"
  data <- list(bool = TRUE)


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "| A  E |", label=deparse(str), info="Nested truthy sections should be omitted.")
})

test_that( "Context Misses", {
  #"Failed context lookups should be considered falsey."
  template <- "[{{^missing}}Cannot find key 'missing'!{{/missing}}]"
  data <- list()


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "[Cannot find key 'missing'!]", label=deparse(str), info="Failed context lookups should be considered falsey.")
})

test_that( "Dotted Names - Truthy", {
  #"Dotted names should be valid for Inverted Section tags."
  template <- "\"{{^a.b.c}}Not Here{{/a.b.c}}\" == \"\""
  data <- list(a = list(b = list(c = TRUE)))


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "\"\" == \"\"", label=deparse(str), info="Dotted names should be valid for Inverted Section tags.")
})

test_that( "Dotted Names - Falsey", {
  #"Dotted names should be valid for Inverted Section tags."
  template <- "\"{{^a.b.c}}Not Here{{/a.b.c}}\" == \"Not Here\""
  data <- list(a = list(b = list(c = FALSE)))


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "\"Not Here\" == \"Not Here\"", label=deparse(str), info="Dotted names should be valid for Inverted Section tags.")
})

test_that( "Dotted Names - Broken Chains", {
  #"Dotted names that cannot be resolved should be considered falsey."
  template <- "\"{{^a.b.c}}Not Here{{/a.b.c}}\" == \"Not Here\""
  data <- list(a = list())


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "\"Not Here\" == \"Not Here\"", label=deparse(str), info="Dotted names that cannot be resolved should be considered falsey.")
})

test_that( "Surrounding Whitespace", {
  #"Inverted sections should not alter surrounding whitespace."
  template <- " | {{^boolean}}\t|\t{{/boolean}} | \n"
  data <- list(boolean = FALSE)


  str <- whisker.render(template, data=data)
  
  expect_equal(str, " | \t|\t | \n", label=deparse(str), info="Inverted sections should not alter surrounding whitespace.")
})

test_that( "Internal Whitespace", {
  #"Inverted should not alter internal whitespace."
  template <- " | {{^boolean}} {{! Important Whitespace }}\n {{/boolean}} | \n"
  data <- list(boolean = FALSE)


  str <- whisker.render(template, data=data)
  
  expect_equal(str, " |  \n  | \n", label=deparse(str), info="Inverted should not alter internal whitespace.")
})

test_that( "Indented Inline Sections", {
  #"Single-line sections should not alter surrounding whitespace."
  template <- " {{^boolean}}NO{{/boolean}}\n {{^boolean}}WAY{{/boolean}}\n"
  data <- list(boolean = FALSE)


  str <- whisker.render(template, data=data)
  
  expect_equal(str, " NO\n WAY\n", label=deparse(str), info="Single-line sections should not alter surrounding whitespace.")
})

test_that( "Standalone Lines", {
  #"Standalone lines should be removed from the template."
  template <- "| This Is\n{{^boolean}}\n|\n{{/boolean}}\n| A Line\n"
  data <- list(boolean = FALSE)


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "| This Is\n|\n| A Line\n", label=deparse(str), info="Standalone lines should be removed from the template.")
})

test_that( "Standalone Indented Lines", {
  #"Standalone indented lines should be removed from the template."
  template <- "| This Is\n  {{^boolean}}\n|\n  {{/boolean}}\n| A Line\n"
  data <- list(boolean = FALSE)


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "| This Is\n|\n| A Line\n", label=deparse(str), info="Standalone indented lines should be removed from the template.")
})

test_that( "Standalone Line Endings", {
  #"\"\\r\\n\" should be considered a newline for standalone tags."
  template <- "|\r\n{{^boolean}}\r\n{{/boolean}}\r\n|"
  data <- list(boolean = FALSE)


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "|\r\n|", label=deparse(str), info="\"\\r\\n\" should be considered a newline for standalone tags.")
})

test_that( "Standalone Without Previous Line", {
  #"Standalone tags should not require a newline to precede them."
  template <- "  {{^boolean}}\n^{{/boolean}}\n/"
  data <- list(boolean = FALSE)


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "^\n/", label=deparse(str), info="Standalone tags should not require a newline to precede them.")
})

test_that( "Standalone Without Newline", {
  #"Standalone tags should not require a newline to follow them."
  template <- "^{{^boolean}}\n/\n  {{/boolean}}"
  data <- list(boolean = FALSE)


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "^\n/\n", label=deparse(str), info="Standalone tags should not require a newline to follow them.")
})

test_that( "Padding", {
  #"Superfluous in-tag whitespace should be ignored."
  template <- "|{{^ boolean }}={{/ boolean }}|"
  data <- list(boolean = FALSE)


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "|=|", label=deparse(str), info="Superfluous in-tag whitespace should be ignored.")
})

# Automatically generated from specification file: 'interpolation.json'
#
# Interpolation tags are used to integrate dynamic content into the template.
# 
# The tag's content MUST be a non-whitespace character sequence NOT containing
# the current closing delimiter.
# 
# This tag's content names the data to replace the tag.  A single period (`.`)
# indicates that the item currently sitting atop the context stack should be
# used; otherwise, name resolution is as follows:
#   1) Split the name on periods; the first part is the name to resolve, any
#   remaining parts should be retained.
#   2) Walk the context stack from top to bottom, finding the first context
#   that is a) a hash containing the name as a key OR b) an object responding
#   to a method with the given name.
#   3) If the context is a hash, the data is the value associated with the
#   name.
#   4) If the context is an object, the data is the value returned by the
#   method with the given name.
#   5) If any name parts were retained in step 1, each should be resolved
#   against a context stack containing only the result from the former
#   resolution.  If any part fails resolution, the result should be considered
#   falsey, and should interpolate as the empty string.
# Data should be coerced into a string (and escaped, if appropriate) before
# interpolation.
# 
# The Interpolation tags MUST NOT be treated as standalone.
# 
library(testthat)
context('Spec v1.1, interpolation')

test_that( "No Interpolation", {
  #"Mustache-free templates should render as-is."
  template <- "Hello from {Mustache}!\n"
  data <- list()


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "Hello from {Mustache}!\n", label=deparse(str), info="Mustache-free templates should render as-is.")
})

test_that( "Basic Interpolation", {
  #"Unadorned tags should interpolate content into the template."
  template <- "Hello, {{subject}}!\n"
  data <- list(subject = "world")


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "Hello, world!\n", label=deparse(str), info="Unadorned tags should interpolate content into the template.")
})

test_that( "HTML Escaping", {
  #"Basic interpolation should be HTML escaped."
  template <- "These characters should be HTML escaped: {{forbidden}}\n"
  data <- list(forbidden = "& \" < >")


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "These characters should be HTML escaped: &amp; &quot; &lt; &gt;\n", label=deparse(str), info="Basic interpolation should be HTML escaped.")
})

test_that( "Triple Mustache", {
  #"Triple mustaches should interpolate without HTML escaping."
  template <- "These characters should not be HTML escaped: {{{forbidden}}}\n"
  data <- list(forbidden = "& \" < >")


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "These characters should not be HTML escaped: & \" < >\n", label=deparse(str), info="Triple mustaches should interpolate without HTML escaping.")
})

test_that( "Ampersand", {
  #"Ampersand should interpolate without HTML escaping."
  template <- "These characters should not be HTML escaped: {{&forbidden}}\n"
  data <- list(forbidden = "& \" < >")


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "These characters should not be HTML escaped: & \" < >\n", label=deparse(str), info="Ampersand should interpolate without HTML escaping.")
})

test_that( "Basic Integer Interpolation", {
  #"Integers should interpolate seamlessly."
  template <- "\"{{mph}} miles an hour!\""
  data <- list(mph = 85)


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "\"85 miles an hour!\"", label=deparse(str), info="Integers should interpolate seamlessly.")
})

test_that( "Triple Mustache Integer Interpolation", {
  #"Integers should interpolate seamlessly."
  template <- "\"{{{mph}}} miles an hour!\""
  data <- list(mph = 85)


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "\"85 miles an hour!\"", label=deparse(str), info="Integers should interpolate seamlessly.")
})

test_that( "Ampersand Integer Interpolation", {
  #"Integers should interpolate seamlessly."
  template <- "\"{{&mph}} miles an hour!\""
  data <- list(mph = 85)


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "\"85 miles an hour!\"", label=deparse(str), info="Integers should interpolate seamlessly.")
})

test_that( "Basic Decimal Interpolation", {
  #"Decimals should interpolate seamlessly with proper significance."
  template <- "\"{{power}} jiggawatts!\""
  data <- list(power = 1.21)


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "\"1.21 jiggawatts!\"", label=deparse(str), info="Decimals should interpolate seamlessly with proper significance.")
})

test_that( "Triple Mustache Decimal Interpolation", {
  #"Decimals should interpolate seamlessly with proper significance."
  template <- "\"{{{power}}} jiggawatts!\""
  data <- list(power = 1.21)


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "\"1.21 jiggawatts!\"", label=deparse(str), info="Decimals should interpolate seamlessly with proper significance.")
})

test_that( "Ampersand Decimal Interpolation", {
  #"Decimals should interpolate seamlessly with proper significance."
  template <- "\"{{&power}} jiggawatts!\""
  data <- list(power = 1.21)


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "\"1.21 jiggawatts!\"", label=deparse(str), info="Decimals should interpolate seamlessly with proper significance.")
})

test_that( "Basic Context Miss Interpolation", {
  #"Failed context lookups should default to empty strings."
  template <- "I ({{cannot}}) be seen!"
  data <- list()


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "I () be seen!", label=deparse(str), info="Failed context lookups should default to empty strings.")
})

test_that( "Triple Mustache Context Miss Interpolation", {
  #"Failed context lookups should default to empty strings."
  template <- "I ({{{cannot}}}) be seen!"
  data <- list()


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "I () be seen!", label=deparse(str), info="Failed context lookups should default to empty strings.")
})

test_that( "Ampersand Context Miss Interpolation", {
  #"Failed context lookups should default to empty strings."
  template <- "I ({{&cannot}}) be seen!"
  data <- list()


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "I () be seen!", label=deparse(str), info="Failed context lookups should default to empty strings.")
})

test_that( "Dotted Names - Basic Interpolation", {
  #"Dotted names should be considered a form of shorthand for sections."
  template <- "\"{{person.name}}\" == \"{{#person}}{{name}}{{/person}}\""
  data <- list(person = list(name = "Joe"))


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "\"Joe\" == \"Joe\"", label=deparse(str), info="Dotted names should be considered a form of shorthand for sections.")
})

test_that( "Dotted Names - Triple Mustache Interpolation", {
  #"Dotted names should be considered a form of shorthand for sections."
  template <- "\"{{{person.name}}}\" == \"{{#person}}{{{name}}}{{/person}}\""
  data <- list(person = list(name = "Joe"))


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "\"Joe\" == \"Joe\"", label=deparse(str), info="Dotted names should be considered a form of shorthand for sections.")
})

test_that( "Dotted Names - Ampersand Interpolation", {
  #"Dotted names should be considered a form of shorthand for sections."
  template <- "\"{{&person.name}}\" == \"{{#person}}{{&name}}{{/person}}\""
  data <- list(person = list(name = "Joe"))


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "\"Joe\" == \"Joe\"", label=deparse(str), info="Dotted names should be considered a form of shorthand for sections.")
})

test_that( "Dotted Names - Arbitrary Depth", {
  #"Dotted names should be functional to any level of nesting."
  template <- "\"{{a.b.c.d.e.name}}\" == \"Phil\""
  data <- list(a = list(b = list(c = list(d = list(e = list(name = "Phil"))))))


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "\"Phil\" == \"Phil\"", label=deparse(str), info="Dotted names should be functional to any level of nesting.")
})

test_that( "Dotted Names - Broken Chains", {
  #"Any falsey value prior to the last part of the name should yield ''."
  template <- "\"{{a.b.c}}\" == \"\""
  data <- list(a = list())


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "\"\" == \"\"", label=deparse(str), info="Any falsey value prior to the last part of the name should yield ''.")
})

test_that( "Dotted Names - Broken Chain Resolution", {
  #"Each part of a dotted name should resolve only against its parent."
  template <- "\"{{a.b.c.name}}\" == \"\""
  data <- list(a = list(b = list()), c = list(name = "Jim"))


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "\"\" == \"\"", label=deparse(str), info="Each part of a dotted name should resolve only against its parent.")
})

test_that( "Dotted Names - Initial Resolution", {
  #"The first part of a dotted name should resolve as any other name."
  template <- "\"{{#a}}{{b.c.d.e.name}}{{/a}}\" == \"Phil\""
  data <- list(a = list(b = list(c = list(d = list(e = list(name = "Phil"))))), 
    b = list(c = list(d = list(e = list(name = "Wrong")))))


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "\"Phil\" == \"Phil\"", label=deparse(str), info="The first part of a dotted name should resolve as any other name.")
})

test_that( "Interpolation - Surrounding Whitespace", {
  #"Interpolation should not alter surrounding whitespace."
  template <- "| {{string}} |"
  data <- list(string = "---")


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "| --- |", label=deparse(str), info="Interpolation should not alter surrounding whitespace.")
})

test_that( "Triple Mustache - Surrounding Whitespace", {
  #"Interpolation should not alter surrounding whitespace."
  template <- "| {{{string}}} |"
  data <- list(string = "---")


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "| --- |", label=deparse(str), info="Interpolation should not alter surrounding whitespace.")
})

test_that( "Ampersand - Surrounding Whitespace", {
  #"Interpolation should not alter surrounding whitespace."
  template <- "| {{&string}} |"
  data <- list(string = "---")


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "| --- |", label=deparse(str), info="Interpolation should not alter surrounding whitespace.")
})

test_that( "Interpolation - Standalone", {
  #"Standalone interpolation should not alter surrounding whitespace."
  template <- "  {{string}}\n"
  data <- list(string = "---")


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "  ---\n", label=deparse(str), info="Standalone interpolation should not alter surrounding whitespace.")
})

test_that( "Triple Mustache - Standalone", {
  #"Standalone interpolation should not alter surrounding whitespace."
  template <- "  {{{string}}}\n"
  data <- list(string = "---")


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "  ---\n", label=deparse(str), info="Standalone interpolation should not alter surrounding whitespace.")
})

test_that( "Ampersand - Standalone", {
  #"Standalone interpolation should not alter surrounding whitespace."
  template <- "  {{&string}}\n"
  data <- list(string = "---")


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "  ---\n", label=deparse(str), info="Standalone interpolation should not alter surrounding whitespace.")
})

test_that( "Interpolation With Padding", {
  #"Superfluous in-tag whitespace should be ignored."
  template <- "|{{ string }}|"
  data <- list(string = "---")


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "|---|", label=deparse(str), info="Superfluous in-tag whitespace should be ignored.")
})

test_that( "Triple Mustache With Padding", {
  #"Superfluous in-tag whitespace should be ignored."
  template <- "|{{{ string }}}|"
  data <- list(string = "---")


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "|---|", label=deparse(str), info="Superfluous in-tag whitespace should be ignored.")
})

test_that( "Ampersand With Padding", {
  #"Superfluous in-tag whitespace should be ignored."
  template <- "|{{& string }}|"
  data <- list(string = "---")


  str <- whisker.render(template, data=data)
  
  expect_equal(str, "|---|", label=deparse(str), info="Superfluous in-tag whitespace should be ignored.")
})
